.DEVICE ATtiny13	;fr gavrasm, fr Symbolische Registerbezeichnungen (z.B.'DDRB')
.cseg
.org 0
; 
; Pseudo-Zufallszahlen = weisses Rauschen durch Simulation eines 
; 22-Bit-Schieberegister (mit Exor der beiden rechten Bit)
; 
; fo = 1,2 MHz / 11,5 Cyclen / 2 = 52174 Hz
; fu = fo / 2^22-1 = 52174 Hz / 4194303 = 0,012 Hz 
;
init:			; 
	ldi r16,31	; alle Ports auf Ausgang
	out DdrB,r16	; 
Main:			; 
	out PortB,r16	; die letztne 5 Bit ausgeben (1.Ausgabe = 31 = 11111)
	mov r19,r16	; obwohl alle Bit gespeichert werden, geht es nur um das letzte Bit
			; (Schieberegister)
	ror r18		; alles 1 Bit nach rechts, das rechte in Carry
	ror r17		; von Carry in Bit 7, alles 1 Bit nach rechts, das rechte in Carry
	ror r16		; nocheinmal, nun ist das ursprngliche Bit 2 in Bit 1
			; (Carry = Bit 2 Exor Bit 1)
	eor r19,r16	; EXOR, hier interessiert nur r19,1 xor r16.1
	ror r19		; das rechte Bit in Carry schieben
			; (1 oder 0 oben einschreiben)
	brbs 0,eins	; wenn C=1 springe nach eins, wenn nicht dann ist in C=0
	andi r18,31	; also wird eine '0' in r18.5=0 geschrieben, r18 = xx0x xxxx
	rjmp Main	; nchster Schiebetakt 
eins:			; hier landen wir nur, wenn in C=1 war
	ori r18,32	; also wird eine '1' in r18.5=1 geschrieben, r18 = xx1x xxxx
	rjmp Main	; nchster Schiebetakt
